﻿using UniversityContracts.BindingModels;
using UniversityContracts.ViewModels;
using UniversityDataModels.Models;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace UniversityDatabaseImplement.Models
{
    public class ReportType : IReportTypeModel
    {
        public int Id { get; set; }
        [Required]
        public string Name { get; set; } = string.Empty;
        [ForeignKey("ReportTypeId")]
        public virtual List<ReportTypeActivity> ReportTypeActivities { get; set; } = new();
        [ForeignKey("ReportTypeId")]
        public virtual List<ReportTypeDiscipline> ReportTypeDisciplines { get; set; } = new();
        public static ReportType Create(ReportTypeBindingModel model)
        {
            return new ReportType
            {
                Id = model.Id,
                Name = model.Name
            };
        }
        public void Update(ReportTypeBindingModel model)
        {
            if (model == null) return;

            Id = model.Id;
            Name = model.Name;
        }

        public ReportTypeViewModel GetViewModel => new()
        {
            Id = Id,
            Name = Name
        };
    }
}
